---
title: Media
slug: Web/Progressive_web_apps/Responsive/Media_types
tags:
  - CSS
  - Example
  - Guide
  - Intermediate
  - NeedsMarkupWork
  - NeedsUpdate
  - Web
---
<div>{{QuickLinksWithSubpages("/en-US/docs/Web/Progressive_web_apps/Responsive/")}}</div>

<p class="summary">This is the 14th and last section of Part I of the <a href="/en-US/docs/Web/Guide/CSS/Getting_Started">CSS Getting Started</a> tutorial. Many pages in this tutorial focused on the CSS properties and values, as well as how you use these to specify the way that content displays.</p>

<h2 class="clearLeft" id="Information_Media">Information: Media</h2>

<p>The purpose of CSS is to specify how content is presented to the user. This presentation can take more than one form.</p>

<p>For example, you are probably reading this on a device with a display. But you might also want to project it to a big screen for a large audience, or you might want to print it. These different media have different characteristics. CSS has the capacity to present content according to the media type.</p>

<p>To specify rules that are specific to a type of media, use {{CSSxRef("@media")}} followed by the media type, followed by curly braces that enclose the rules.</p>

<div class="tuto_example">
<h4 class="tuto_type" id="Example">Example</h4>

<p>A document on a website has a navigation area that contains the primary site menu.</p>

<p>In the markup language, the navigation area's parent element has the <strong>id</strong> <code>nav-area</code>. (In {{HTMLVersionInline(5)}}, this can be marked up with the {{HTMLElement("nav")}} element instead of {{HTMLElement("div")}} with an <strong>id</strong> attribute.)</p>

<p>When printing the document, the navigation area has no purpose. This CSS (below) removes the navigation area when printing the document:</p>

<pre class="brush:css notranslate">@media print {
  #nav-area {display: none;}
  }
</pre>
</div>

<p>Some common media types are:</p>

<table class="standard-table">
 <tbody>
  <tr>
   <td><code>screen</code></td>
   <td>Color device display</td>
  </tr>
  <tr>
   <td><code>print</code></td>
   <td>Printed paged media</td>
  </tr>
  <tr>
   <td style="padding-right: 1em;"><code>projection</code></td>
   <td>Projected display</td>
  </tr>
  <tr>
   <td><code>all</code></td>
   <td>All media (the default)</td>
  </tr>
 </tbody>
</table>

<div class="tuto_details">
<h4 class="tuto_type" id="More_details">More details</h4>

<p>There are other ways to specify the media type for a set of rules.</p>

<p>The document's markup language might allow the media type to be specified when the stylesheet is linked to the document. For example, in HTML, you have the option to specify the media type with a <code>media</code> attribute in the <code>LINK</code> element.</p>

<p>In CSS, you can use {{CSSxRef("@import")}} at the start of a stylesheet to import another stylesheet from a URL, optionally specifying the media type.</p>

<p>These are ways of separating styling rules for different media types into different files.</p>

<p>For full details of media types, see <a href="http://www.w3.org/TR/CSS21/media.html">Media</a> in the CSS Specification.</p>

<p>There are more examples of the {{CSSxRef("display")}} property in a later page in this tutorial: <a href="/en-US/docs/Web/Guide/CSS/Getting_Started/XML_data">XML data</a>.</p>
</div>

<h3 id="Printing">Printing</h3>

<p>CSS has specific support for printing and for paged media in general.</p>

<p>A {{CSSxRef("@page")}} rule can set the page margins. For double-sided printing, you can specify the margins separately for <code>@page:left</code> and <code>@page:right</code>.</p>

<p>For print media, you normally use appropriate length units like inches (<code>in</code>) and points (<code>pt</code> = 1/72 inch), or centimeters (<code>cm</code>) and millimeters (<code>mm</code>). It is equally appropriate to use ems (<code>em</code>) to match the font size, and percentages (<code>%</code>).</p>

<p>You can control how the content of the document breaks across page boundaries, by using the {{CSSxRef("page-break-before")}}, {{CSSxRef("page-break-after")}} and {{CSSxRef("page-break-inside")}} properties.</p>

<div class="tuto_example">
<h4 class="tuto_type" id="Example_2">Example</h4>

<p>This rule sets the page margins to one inch on all four sides:</p>

<pre class="brush:css notranslate">@page {margin: 1in;}
</pre>

<p>This rule ensures that every <small>H1</small> element starts on a new page:</p>

<pre class="brush:css notranslate">h1 {page-break-before: always;}
</pre>
</div>

<div class="tuto_details">
<h4 class="tuto_type" id="More_details_2">More details</h4>

<p>For full details of CSS support for paged media, see <a href="http://www.w3.org/TR/CSS21/page.html">Paged media</a> in the CSS Specification.</p>

<p>Like other features of CSS, printing depends on browser choice and its settings. For example, the Mozilla browser supplies default margins, headers, and footers for printing. Keep in mind that you can't completely control the printed format. It is impossible to anticipate every user's browser choice and settings at the time of printing.</p>
</div>

<h3 id="User_interfaces">User interfaces</h3>

<p>CSS has some special properties for devices that support a user interface, like computer displays. These properties dynamically change the appearance of content as the user works with the interface.</p>

<p>There are five special selectors:</p>

<table class="standard-table">
 <tbody>
  <tr>
   <td><strong>Selector</strong></td>
   <td><strong>Selects</strong></td>
  </tr>
  <tr>
   <td><code>E{{CSSxRef(":hover")}}</code></td>
   <td>Any E element that has the pointer over it</td>
  </tr>
  <tr>
   <td><code>E{{CSSxRef(":focus")}}</code></td>
   <td>Any E element that has keyboard focus</td>
  </tr>
  <tr>
   <td><code>E{{CSSxRef(":active")}}</code></td>
   <td>The E element that is involved in the current user action</td>
  </tr>
  <tr>
   <td><code>E{{CSSxRef(":link")}}</code></td>
   <td>Any E element that is a hyperlink to a URL that the user has <em>not</em> visited recently</td>
  </tr>
  <tr>
   <td><code>E{{CSSxRef(":visited")}}</code></td>
   <td>Any E element that is a hyperlink to a URL that the user <em>has</em> visited recently</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p><strong>Note: </strong>The information that can be obtained from the :visited selector is restricted in {{gecko("2.0")}}. See <a href="/en-US/docs/Web/CSS/Privacy_and_the_:visited_selector">Privacy and the :visited selector</a> for more details.</p>
</div>

<p>The {{CSSxRef("cursor")}} property specifies the shape of the pointer: Some of the common shapes are as follows. Place your mouse over the items in this list to see the actual pointer shapes in your browser:</p>

<table class="standard-table">
 <thead>
  <tr>
   <td><strong>Selector</strong></td>
   <td><strong>Selects</strong></td>
  </tr>
 </thead>
 <tbody>
  <tr style="cursor: pointer;">
   <td><code>pointer</code></td>
   <td>Indicating a link</td>
  </tr>
  <tr style="cursor: wait;">
   <td><code>wait</code></td>
   <td>Indicating that the program cannot accept input</td>
  </tr>
  <tr style="cursor: progress;">
   <td><code>progress</code></td>
   <td>Indicating that the program is working, but can still accept input</td>
  </tr>
  <tr style="cursor: default;">
   <td><code>default</code></td>
   <td>The default (usually an arrow)</td>
  </tr>
 </tbody>
</table>

<p>An {{CSSxRef("outline")}} property creates an outline that is often used to indicate keyboard focus. Its values are similar to the {{CSSxRef("border")}} property, except that you cannot specify individual sides.</p>

<p>Some other features of user interfaces are implemented using attributes, in the normal way. For example, an element that is disabled or read-only has the <strong>disabled</strong> attribute or the <strong>readonly</strong> attribute. Selectors can specify these attributes like any other attributes, by using square brackets: <code>[disabled]</code> or <code>[readonly]</code>.</p>

<div class="tuto_example">
<h4 class="tuto_type" id="Example_3">Example</h4>

<p>These rules specify styles for a button that changes dynamically as the user interacts with it:</p>

<pre class="brush:css notranslate">.green-button {
  background-color:#cec;
  color:#black;
  border:2px outset #cec;
  padding: 5px 10px;
  }

.green-button[disabled] {
  background-color:#cdc;
  color:#777;
  }

.green-button:active, .green-button.active {
  border-style: inset;
  }
</pre>

<pre class="brush:html notranslate">&lt;table&gt;
 &lt;tbody&gt;
  &lt;tr&gt;
   &lt;td&gt;&lt;button class="green-button" disabled&gt;Click me&lt;/button&gt;&lt;/td&gt;
   &lt;td&gt;&lt;button class="green-button"&gt;Click me&lt;/button&gt;&lt;/td&gt;
   &lt;td&gt;&lt;button class="green-button active"&gt;Click me&lt;/button&gt;&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr style="line-height:25%;"&gt;
   &lt;td&gt;&amp;nbsp;&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr style="font-style:italic;"&gt;
   &lt;td&gt;disabled&lt;/td&gt;
   &lt;td&gt;normal&lt;/td&gt;
   &lt;td&gt;active&lt;/td&gt;
  &lt;/tr&gt;
 &lt;/tbody&gt;
&lt;/table&gt;
</pre>

<h4 id="Live_Sample"><strong>Live Sample</strong></h4>

<p>{{ EmbedLiveSample('User_interfaces', '', '', '', 'Web/Apps/Progressive/Responsive/Media_types') }}</p>

<p>A fully functional button also has a dark outline around the entire button when it is the default, and a dotted outline on the face of the button when it has keyboard focus. It might also have a hover effect when the pointer is over it.</p>
</div>

<div class="tuto_details">
<h4 class="tuto_type" id="More_details_3">More details</h4>

<p>For more information about user interfaces in CSS, see <a href="http://www.w3.org/TR/CSS21/ui.html">User interface</a> in the CSS Specification. In Part II of this tutorial, there is an example of Mozilla's markup language for user interfaces.</p>
</div>

<h2 id="Action_Printing_a_document">Action: Printing a document</h2>

<div class="note">
<p><strong>Note:</strong> This snippet only works on Firefox since it erroneously increments the CSS counter for fix-position elements. It should not work in other browsers. See <a href="/en-US/docs/">issue on css3-page</a>.</p>
</div>

<ol>
 <li>Make a new HTML document, <code>doc4.html</code>. Copy and paste the content from here:

  <pre class="brush:html notranslate">&lt;!DOCTYPE html&gt;
&lt;html&gt;
  &lt;head&gt;
    &lt;title&gt;Print sample&lt;/title&gt;
    &lt;link rel="stylesheet" href="style4.css"&gt;
  &lt;/head&gt;
  &lt;body&gt;
    &lt;h1&gt;Section A&lt;/h1&gt;
    &lt;p&gt;This is the first section...&lt;/p&gt;
    &lt;h1&gt;Section B&lt;/h1&gt;
    &lt;p&gt;This is the second section...&lt;/p&gt;
    &lt;div id="print-head"&gt;
      Heading for paged media
    &lt;/div&gt;
    &lt;div id="print-foot"&gt;
      Page:
    &lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>
 </li>
 <li>Make a new stylesheet, <code>style4.css</code>. Copy and paste the content from here:
  <pre class="brush:css notranslate">/*** Print sample ***/

/* defaults  for screen */
#print-head,
#print-foot {
  display: none;
  }

/* print only */
@media print {

h1 {
  page-break-before: always;
  padding-top: 2em;
  }

h1:first-child {
  page-break-before: avoid;
  counter-reset: page;
  }

#print-head {
  display: block;
  position: fixed;
  top: 0pt;
  left:0pt;
  right: 0pt;

  font-size: 200%;
  text-align: center;
  }

#print-foot {
  display: block;
  position: fixed;
  bottom: 0pt;
  right: 0pt;

  font-size: 200%;
  }

#print-foot:after {
  content: counter(page);
  counter-increment: page;
  }

} /* end print only */
</pre>
 </li>
 <li>View this document in your browser. It uses your browser's default style.</li>
 <li>Print (or print preview) the document. The stylesheet places each section on a separate page, and it adds a header and footer to each page. If your browser supports counters, it adds a page number in the footer.
  <table>
   <tbody>
    <tr>
     <td>
      <table style="border: 2px outset #3366bb; padding: 1em;">
       <tbody>
        <tr>
         <td>
          <table style="margin-right: 2em; width: 15em;">
           <tbody>
            <tr>
             <td>
              <div style="font-size: 110%; text-align: center; margin-bottom: .5em;">Heading for paged media</div>

              <div style="font-size: 150%; font-weight: bold;">Section A</div>

              <div style="font-size: 75%;">This is the first section...</div>

              <div style="font-size: 150%; text-align: right; margin-top: 12em;">Page: 1</div>
             </td>
            </tr>
           </tbody>
          </table>
         </td>
        </tr>
       </tbody>
      </table>
     </td>
     <td>
      <table style="border: 2px outset #3366bb; padding: 1em;">
       <tbody>
        <tr>
         <td>
          <table style="margin-right: 2em; width: 15em;">
           <tbody>
            <tr>
             <td>
              <div style="font-size: 110%; text-align: center; margin-bottom: .5em;">Heading for paged media</div>

              <div style="font-size: 150%; font-weight: bold;">Section B</div>

              <div style="font-size: 75%;">This is the second section...</div>

              <div style="font-size: 150%; text-align: right; margin-top: 12em;">Page: 2</div>
             </td>
            </tr>
           </tbody>
          </table>
         </td>
        </tr>
       </tbody>
      </table>
     </td>
    </tr>
   </tbody>
  </table>
 </li>
</ol>

<table style="background-color: #fffff4; border: 1px solid #3366bb; padding: 1em; width: 100%;">
 <caption>
 <h4 id="Challenges"><strong>Challenges</strong></h4>
 </caption>
 <tbody>
  <tr>
   <td>Move the print-specific style rules to a separate CSS file.
    <p>Read the {{CSSxRef("@import")}} reference page to find details of how to import the new print-specific CSS file into your <code>style4.css</code> stylesheet.</p>

    <p>Make the headings turn blue when the mouse pointer is over them.</p>
   </td>
  </tr>
 </tbody>
</table>

<p><a href="/en-US/docs/Web/Guide/CSS/Getting_Started/Challenge_solutions#Media">See solutions to these challenges.</a></p>

<h2 id="What_next">What next?</h2>

<p>If you had difficulty understanding this page, or if you have other comments about it, please contribute to its <a href="/Talk:en-US/docs/Web/Guide/CSS/Getting_Started/Media">Discussion</a> page.</p>

<p>So far, all the style rules in this tutorial have been specified in files. The rules and their values are fixed. The next page describes how you can change rules dynamically by using a programming language: <strong><a href="/en-US/docs/Web/Guide/CSS/Getting_Started/JavaScript">JavaScript</a></strong>.</p>
